/* $Id: wvlan_gtk.c,v 1.2 2001/03/13 15:59:29 tobi Exp $ */

#include <config.h>

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <time.h>
#include <gnome.h>
#include <applet-widget.h>

#include "wvlan_mon.h"

unsigned val[BAR_SIZE];
static GtkWidget *proc;

static GdkColor bar_colors [BAR_SIZE-1] = {
	{0, 0xffff, 0, 0},
	{0, 0, 0, 0},

};

int update_values () {
	my_info *info;
	
	info=get_dev();
	val[0]=92;
	if(!info) {
		val[1]=0;
		val[2]=92;
	} else {
		val[1]=info->linkq;
		val[2]=92-info->linkq;
	}
	
	gnome_proc_bar_set_values(GNOME_PROC_BAR(proc),val);

	if(info) {
		free(info->netdev);
		free(info);
	}
	return TRUE;
}

int init_widget() {
	proc = gnome_proc_bar_new(NULL, BAR_SIZE-1, bar_colors, update_values);
	gnome_proc_bar_set_orient(GNOME_PROC_BAR(proc), FALSE);

	update_values();

	gnome_proc_bar_start(GNOME_PROC_BAR(proc), 1200, NULL);
	return TRUE;
}

static void wvlan_mon_about (AppletWidget *applet, gpointer data) {
	static GtkWidget *about =NULL;
	static const gchar *authors[] =
	{
		"Tobias Rundstrm <tobi@debian.as>",
		NULL
	};

	if(about != NULL)
	{
		gdk_window_show(about->window);
		gdk_window_raise(about->window);
		return;
	}

	about=gnome_about_new(_("WaveLan Link Quality Monitor"), "0.1", _("(C) 2001 Tobias Rundstrm"),authors,_("The WvLanMon will show how good your link to the Access Point is\nand (someday) maybe some more info..."),NULL);
	gtk_signal_connect(GTK_OBJECT(about),"destroy",GTK_SIGNAL_FUNC(gtk_widget_destroyed),&about);
	gtk_widget_show(about);
}


int main (int argc, char **argv) {
	GtkWidget *applet;

	bindtextdomain(PACKAGE,GNOMELOCALEDIR);
	textdomain(PACKAGE);

	applet_widget_init("wvlanmon_applet",VERSION,argc,argv,NULL,0,NULL);

	applet=applet_widget_new("wvlanmon_applet");
	if(!applet)
		g_error("Can't create applet!\n");

	init_widget();

	gtk_widget_set_usize(proc,40,15);

	applet_widget_add(APPLET_WIDGET(applet), proc);
	applet_widget_register_stock_callback(APPLET_WIDGET(applet),
		"about",
		GNOME_STOCK_PIXMAP_ABOUT,
		_("About"),
		wvlan_mon_about,
		NULL);
		
	gtk_widget_show_all(applet);
	applet_widget_gtk_main();

	return 0;
}
